#include <sys/cdefs.h>
#include <sys/types.h>

#include <geom/gate/g_gate.h>

#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <strings.h>

int
main (int argc, char *argv[])
{
	struct g_gate_ctl_create ggiocreate;
	struct g_gate_ctl_cancel ggiocancel;
	struct g_gate_ctl_destroy ggiod;
	int fd, unit;

	if (argc < 2)
		errx(1, "usage: ggiocreate name");
	
	fd = open("/dev/" G_GATE_CTL_NAME, O_RDWR);
	if (fd < 0)
		err(1, "Unable to open /dev/" G_GATE_CTL_NAME);
	bzero(&ggiocreate, sizeof(ggiocreate));
	ggiocreate.gctl_version = G_GATE_VERSION;
	ggiocreate.gctl_mediasize = 1024 * 10240;
	ggiocreate.gctl_sectorsize = 512;
	ggiocreate.gctl_flags = 0;
	ggiocreate.gctl_maxcount = G_GATE_MAX_QUEUE_SIZE;
	ggiocreate.gctl_timeout = 0;
	ggiocreate.gctl_unit = G_GATE_NAME_GIVEN;
	snprintf(ggiocreate.gctl_name, sizeof(ggiocreate.gctl_name),
	    "testhast/%s", argv[1]);
	if (ioctl(fd, G_GATE_CMD_CREATE, &ggiocreate) != 0)
		err(1, "Unable to create testhast/%s device", argv[1]);
	else
		unit = ggiocreate.gctl_unit;
	
	sleep(10);

	bzero(&ggiod, sizeof(ggiod));
	ggiod.gctl_version = G_GATE_VERSION;
	ggiod.gctl_unit = unit;
	ggiod.gctl_force = 1;
	if (ioctl(fd, G_GATE_CMD_DESTROY, &ggiod) < 0)
		err(1, "Unable to destroy testhast/%s device", argv[1]);

	return 0;
}
